  .586
.mmx
.xmm

.model flat,stdcall
option casemap:none

ListBoxProc proto hWnd:dword,uMsg:dword,wParam:dword,lParam:dword
ListBoxUpdate proto :dword,:dword
Update proto :dword,:dword,:dword,:dword
TextBoxProc proto hWnd:dword,uMsg:dword,wParam:dword,lParam:dword

literal_string		macro	lit_string
			local	local_string

			.data
			align	4
local_string		db	lit_string, 0

			.code
			exitm	<local_string>
			endm
CADD MACRO quoted_text
      LOCAL vname,lbl
        jmp lbl
          vname db quoted_text,0
        lbl:
      EXITM <ADDR vname>
    ENDM
CSTR			macro	lit_string
			exitm	<offset literal_string(lit_string)>
			endm

   include windows.inc
   include user32.inc
   include kernel32.inc
   include gdi32.inc
   include shell32.inc
   include comdlg32.inc
   include winmm.inc
   include ole32.inc
   include msvfw32.inc
   include avifil32.inc
   include  advapi32.inc
   include wininet.inc
   include avicap32.inc
   include GDIPlus.inc
   Include masm32.inc
   include ucmacros.asm
   include graphics.inc
   include ffile.inc
   include hNullstring.inc
   include arabic_dict.inc
   include sapi_f.inc

  
   includelib masm32.lib
   includelib gdi32.lib
   includelib user32.lib
   includelib kernel32.lib
   includelib winmm.lib
   includelib shell32.lib
	includelib	ole32.lib
	includelib advapi32.lib
	includelib msvfw32.lib
	includelib avifil32.lib
	includelib	oleaut32.lib
	includelib comdlg32.lib
	includelib wininet.lib
	includelib avicap32.lib
	includelib gdiplus.lib
	includelib msvcrt.lib
	includelib Graphics.lib

	
   
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD


     m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM

.data
   ClassName db "GEF",0
   AppName  db "Farabi Arabic Dictionary",0
				
.data?
	hInstance HINSTANCE ?
	CommandLine LPSTR ?
	hwnd dword ?
	wDC dword ?
	
	hEdit dword ?
	hEdit2 dword ?
	hEdit3 dword ?
	lb dword ?
	lbp dword ?
	tbp dword ?
	hBtn dword ?
	dllhnd dword 0
	hFont dword 0
	hDC dword 0
	fFile dword 0
	f_ind dword 0
	
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX 
	LOCAL msg:MSG 
	
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW\
           ,0,\
           0,600,480,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc uses esi edi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL t[256]:dword
	LOCAL t2[256]:dword
	LOCAL buff[256]:dword
	LOCAL e:TEXTRANGE
	LOCAL cntr:dword
	LOCAL tm,am:dword
	
	.IF uMsg==WM_DESTROY		
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE
		
		invoke GetSystemMetrics,SM_CXSCREEN
		cmp eax,600
		jnl @f
			invoke MessageBox,hWnd,CADD("Resolution width less than 600 pixels"),CADD("Execution aborted"),MB_OK
			invoke PostQuitMessage,NULL
		@@:
		
		invoke GetSystemMetrics,SM_CYSCREEN
		cmp eax,480
		jnl @f
			invoke MessageBox,hWnd,CADD("Resolution height less than 480 pixels"),CADD("Execution aborted"),MB_OK
			invoke PostQuitMessage,NULL
		@@:
		invoke LoadLibrary,CADD("RICHED20.DLL")
		.if eax!=0
			mov dllhnd,eax
		.else
			invoke PERR
		.endif
		
		invoke GetWindowDC,hWnd
		mov hDC,eax
		
		
;		[Rich edit creation here]
	    mov   edx,WS_VISIBLE or WS_CHILDWINDOW or WS_VSCROLL or ES_NOHIDESEL or ES_AUTOVSCROLL ;or ES_MULTILINE
	    invoke CreateWindowEx,WS_EX_CLIENTEDGE,CADD("RichEdit20W"),NULL,edx,70,60,440,25,hWnd,799,hInstance,NULL
	    mov   hEdit, eax

	    mov   edx,WS_VISIBLE or WS_CHILDWINDOW or WS_VSCROLL or ES_NOHIDESEL or ES_AUTOVSCROLL or ES_MULTILINE
	 	invoke CreateWindowEx,WS_EX_CLIENTEDGE,CADD("RichEdit20W"),NULL,edx,155,130,400,290,hWnd,799,hInstance,NULL
	    mov   hEdit2, eax
	    
	    invoke SetWindowLongW,hEdit,GWL_WNDPROC,addr TextBoxProc
	    mov tbp,eax
	    
	    invoke MakeFont,12,10,0,CADD("Courier New")
	    mov hFont,eax
	    invoke SendMessage,hEdit2,WM_SETFONT,eax,TRUE
	    invoke SendMessage,hEdit,WM_SETFONT,hFont,TRUE
	    
	    mov   edx, WS_VSCROLL or WS_VISIBLE or \
              WS_BORDER or WS_CHILD or \
              LBS_HASSTRINGS or LBS_NOINTEGRALHEIGHT or \
              LBS_DISABLENOSCROLL
	    invoke CreateWindowEx,WS_EX_CLIENTEDGE,CADD("ListBox"),NULL,edx,0,100,150,320,hWnd,3,hInstance,NULL
	    mov   lb, eax
	    invoke MakeFont,11,FW_NORMAL,0,CADD("Courier New")
		invoke SendMessage,lb,WM_SETFONT,eax,TRUE
		invoke SetWindowLong,lb,GWL_WNDPROC,addr ListBoxProc
		mov lbp,eax
		
		invoke IsWindowUnicode,hEdit
		.if eax==0
			invoke MessageBox,0,CADD("Error: hEdit1 Did not support unicode"),0,0
		.endif
		
		invoke IsWindowUnicode,hEdit2
		.if eax==0
			invoke MessageBox,0,CADD("Error: Did not support unicode"),0,0
		.endif
		
		invoke PushButton,CADD("Find"),hWnd,hInstance,510,60,50,25,2
		invoke PushButton,CADD("Copy"),hWnd,hInstance,155,100,50,25,3
		invoke PushButton,CADD("Paste"),hWnd,hInstance,155+50,100,50,25,4
		invoke PushButton,CADD("Update"),hWnd,hInstance,155+50+50,100,50,25,5
		
		invoke ListBoxUpdate,lb,CADD("qwords.txt")
		invoke OpenFileFrb,CADD("qwords.txt")
		mov fFile,eax
				
		
		invoke SetBkMode,hDC,TRANSPARENT
		invoke SelectObject,hDC,hFont
		invoke DeleteObject,eax
		invoke SetTextColor,hDC,0
		
		invoke SetTimer,hWnd,0,100,addr Update
		
	    
		invoke fCenterWindows,hWnd,600,480
	.elseif uMsg==WM_COMMAND
		.if wParam==1
			
		.elseif wParam==2
			;invoke MessageBox,hWnd,CADD("Clicked"),0,0
		.endif
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	
	xor eax,eax
	ret
WndProc endp

ListBoxUpdate proc uses esi hWnd:dword,lpstr:dword
	LOCAL LC:dword
	LOCAL fsz:dword
	LOCAL buff[1024]:dword
	LOCAL hFile:dword
	
	invoke OpenFileFrb,lpstr
	.if eax==1
		invoke MessageBox,0,CADD("File not found"),0,0
		ret
	.endif
	mov hFile,eax
	
	invoke UMLineCount,hFile
	mov LC,eax
	
	; This technique taken from jj2007, member of www.masm32.com forum
	invoke SendMessage,hWnd,WM_SETREDRAW,0,0
	invoke SendMessage,hWnd,LB_RESETCONTENT,0,0
	
	invoke filesize,lpstr
	mov fsz,eax
	invoke SendMessage,hWnd,LB_INITSTORAGE,LC,fsz
	
	xor ecx,ecx
	loop_insert_string:
	pushad
		inc ecx
		push ecx
		invoke memfill,addr buff,1024,0
		pop ecx
		invoke GetWord,hFile,ecx,1
		invoke MemCopy,[edx].frbWordStruct.lpAddress,addr buff,[edx].frbWordStruct.nSize
		;invOke MessageBox,0,edx,0,0
		invoke SendMessage,hWnd,LB_ADDSTRING,0,addr buff
	popad
	inc ecx
	cmp ecx,LC
	jl loop_insert_string
	
	invoke SendMessage,hWnd,WM_SETREDRAW,1,0
	
	
	invoke CloseFileFrb,hFile
	
	ret
ListBoxUpdate endp

ListBoxProc proc hWnd:dword,uMsg:dword,wParam:dword,lParam:dword
	LOCAL s:dword
	LOCAL buff[256]:dword
	
	.if uMsg==WM_LBUTTONUP
		invoke SendMessage,hWnd,LB_GETCURSEL,0,0
		mov s,eax
		invoke SendMessage,hWnd,LB_GETTEXT,s,addr buff
		invoke MessageBox,hWnd,addr buff,0,0
	.endif 
	
	
	
	invoke CallWindowProc,lbp,hWnd,uMsg,wParam,lParam
	ret
ListBoxProc endp

SearchString proc lpFile:dword,lpString:dword
	LOCAL ln_cnt:dword
	LOCAL buff[256]:dword
	LOCAL l_str:dword
	LOCAL l_fnd:dword
	LOCAL tmp_ecx:dword
	
	invoke UMLineCount,lpFile
	mov ln_cnt,eax
	xor eax,eax
	
	invoke lstrlen,lpString
	dec eax
	mov l_str,eax
	
	xor eax,eax
	dec eax
	xor ecx,ecx
	push ecx
	pop l_fnd
	loop_search:
	pushad
		inc ecx
		mov tmp_ecx,ecx
		push ecx		
			invoke GetWord,lpFile,ecx,1
			mov eax,l_str
		;	.if [edx].frbWordStruct.nSize>=eax
				invoke szCmpi,[edx].frbWordStruct.lpAddress,lpString,l_str
				.if eax==0
					push tmp_ecx
					pop l_fnd
					pop ecx
					popad
					jmp thats_it
				.endif
		;	.endif
		pop ecx
	popad
	inc ecx
	cmp ecx,ln_cnt
	jl loop_search
	thats_it:
	mov eax,l_fnd
	;invoke MessageBox,0,addr buff,0,0
	
	ret
SearchString endp

TextBoxProc proc hWnd:dword,uMsg:dword,wParam:dword,lParam:dword
	LOCAL lptext:dword
	LOCAL buff[256]:dword
	LOCAL hFile:dword 
	LOCAL nIndex:dword
	
	.if uMsg==WM_KEYUP
			invoke mAlloc,1024
			mov lptext,eax
			xor ecx,ecx
			mov ecx,0fffeh
			mov [eax],ecx
			invoke SendMessageW,hEdit,EM_GETLINE,0,lptext
			invoke memfill,addr buff,1024,0
			invoke WideCharToMultiByte,CP_ACP,0,lptext,38,addr buff,MAX_PATH,0,0
			
			invoke SendMessageW,hEdit,EM_LINELENGTH,0,0
			.if eax!=0
				
				invoke SearchString,fFile,addr buff
				mov nIndex,eax
				
			.endif
			
			dec nIndex
			.if nIndex!=-1
				push nIndex
				pop f_ind
			.endif
			
			invoke SendMessage,lb,LB_SETCURSEL,f_ind,0
			
			invoke GlobalFree,lptext
	.endif
	invoke CallWindowProc,tbp,hWnd,uMsg,wParam,lParam
	ret
TextBoxProc endp

Update proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	invoke TextOut,hDC,10,90,CADD("Search:"),7
	
	ret
Update endp


end start