
STISpVoice struct
	SetNotifySink                dword      ?
   SetNotifyWindowMessage       dword      ?
   SetNotifyCallbackFunction    dword      ?
   SetNotifyCallbackInterface   dword      ?
   SetNotifyWin32Event          dword      ?
   WaitForNotifyEvent           dword      ?
   GetNotifyEventHandl          dword      ?
   SetInterest                  dword      ?
   GetEvents                    dword      ?
   GetInfo                      dword      ?
   SetOutput                    dword      ?
   GetOutputObjectToken         dword      ?
   GetOutputStream              dword      ?
   Pause                        dword      ?
   Resume                       dword      ?
   SetVoice                     dword      ?
   GetVoice                     dword      ?
   Speak                        dword      ?
   SpeakStream                  dword      ?
   GetStatus                    dword      ?
   Skip                         dword      ?
   SetPriority                  dword      ?
   GetPriority                  dword      ?
   SetAlertBoundary             dword      ?
   GetAlertBoundary             dword      ?
   SetRate                      dword      ?
   GetRate                      dword      ?
   SetVolume                    dword      ?
   GetVolume                    dword      ?
   WaitUntilDone                dword      ?
   SetSyncSpeakTimeout          dword      ?
   GetSyncSpeakTimeout          dword      ?
   SpeakCompleteEvent           dword      ?
   IsUISupported                dword      ?
   DisplayUI                    dword      ?
STISpVoice ends

SPF_DEFAULT equ 0

.data
IID_ISpVoice   GUID {06C44DF74h,072B9h,04992h,<0A1h,0ECh,0EFh,099h,06Eh,004h,022h,0D4h>}
vi dword 0
.code

GetInterfaceFromProgId PROC pProgId:DWORD,pIID:DWORD
        LOCAL wszProgID[1024]:word
        LOCAL ppv:Dword,retour,pchaine         
        LOCAL clsid     :GUID
        mov retour,0

        invoke MultiByteToWideChar,CP_ACP,MB_PRECOMPOSED,pProgId,-1,addr wszProgID,sizeof wszProgID
        invoke CLSIDFromProgID,addr wszProgID,addr clsid
        .if eax == S_OK
                invoke CoCreateInstance,addr clsid, NULL,CLSCTX_INPROC_SERVER OR CLSCTX_INPROC_HANDLER OR CLSCTX_LOCAL_SERVER,pIID,addr ppv

              .if eax == S_OK                         
                     
              .endif
        .endif
        mov eax,retour
        RET
GetInterfaceFromProgId endp


SpeakInit proc uses esi edi

	invoke GetInterfaceFromProgId,CADD("SAPI.SpVoice.1"),addr IID_ISpVoice
	.if eax==0
		invoke MessageBox,0,CADD("Something was wrong"),0,0
	.else
		mov vi,eax
	.endif

	ret
SpeakInit endp

SpeakSetVolume proc uses esi edi nVolume:dword
	LOCAL x:dword
	;STISpVoice.SetVolume
	
	push nVolume
	mov esi,vi
	push esi
	mov esi,[esi]
	call [esi].STISpVoice.SetVolume
	
	ret
SpeakSetVolume endp

Speak proc uses esi edi lpText:dword
	LOCAL buff[256]:dword
	
	invoke MultiByteToWideChar,CP_ACP,MB_PRECOMPOSED,lpText,-1,addr buff,sizeof buff
	
	
	push SPF_DEFAULT
	lea eax,buff
	push eax
	mov esi,vi
	push esi
	mov esi,[esi]
	call [esi].STISpVoice.Speak
	.if eax!=0
	; xchg edx,eax
	; invoke dw2a,edx,addr buff
	; invoke MessageBox,0,addr buff,0,0
	.endif
	
	ret
Speak endp